package gliparameterizer;

import java.awt.*;
import javax.swing.*;

/**
 * Gives help on file formats in a dialog..
 * <p>Copyright: Copyright (c) 2004 Charles D. Canham</p>
 * <p>Company: Institute of Ecosystem Studies</p>
 * @author Lora E. Murphy
 * @version 1.0
 */

public class Help
    extends JDialog
    implements java.awt.event.ActionListener {

  private JButton m_jLinkButton = new JButton();
  private JEditorPane m_jEditorPane = new JEditorPane();

  /**
   * Constructor.  Builds the dialog.
   * @param jFrame Frame Parent frame.
   */
  public Help(Frame jFrame) {
    super(jFrame, "Help", false);
    m_jEditorPane.setEditable(false);
    String sURL = "help.html";
    java.net.URL jHelpURL = Help.class.getResource(sURL);
    if (jHelpURL != null) {
      try {
        m_jEditorPane.setPage(jHelpURL);
      }
      catch (java.io.IOException e) {
        JOptionPane.showMessageDialog(jFrame,
                                      "Couldn't read help file: " + sURL,
                                      "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
    }
    else {
      JOptionPane.showMessageDialog(jFrame, "Couldn't find file: " + sURL,
                                    "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    //Put the editor pane in a scroll pane.
    JScrollPane jScrollPane = new JScrollPane(m_jEditorPane);
    jScrollPane.setVerticalScrollBarPolicy(
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jScrollPane.setPreferredSize(new Dimension(400, 500));
    jScrollPane.setMinimumSize(new Dimension(10, 10));

    //Button for closing the window
    JButton jOKButton = new JButton("OK");
    jOKButton.setFont(new ModelFont());
    jOKButton.addActionListener(this);
    jOKButton.setActionCommand("OK");

    //Button for opening more help
    m_jLinkButton.setText("GLI Calc Details...");
    m_jLinkButton.setFont(new ModelFont());
    m_jLinkButton.addActionListener(this);
    m_jLinkButton.setActionCommand("Link");

    //Put together the window
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(jScrollPane, BorderLayout.CENTER);
    JPanel jTempPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
    jTempPanel.add(jOKButton);
    jTempPanel.add(m_jLinkButton);
    getContentPane().add(jTempPanel, BorderLayout.SOUTH);

  }

  public void actionPerformed(java.awt.event.ActionEvent e) {
    if (e.getActionCommand().equals("OK")) {
      this.setVisible(false);
      this.dispose();
    }
    else if (e.getActionCommand().equals("Link")) {
      String sURL = "detail.html";
      java.net.URL jHelpURL = Help.class.getResource(sURL);
      if (jHelpURL != null) {
        try {
          m_jEditorPane.setPage(jHelpURL);
        }
        catch (java.io.IOException e1) {
          JOptionPane.showMessageDialog(this,
                                        "Couldn't read help file: " + sURL,
                                        "Error", JOptionPane.ERROR_MESSAGE);
          return;
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Couldn't find file: " + sURL,
                                      "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      m_jLinkButton.setActionCommand("Back");
      m_jLinkButton.setText("Back");
    } else if (e.getActionCommand().equals("Back")) {
      String sURL = "help.html";
      java.net.URL jHelpURL = Help.class.getResource(sURL);
      if (jHelpURL != null) {
        try {
          m_jEditorPane.setPage(jHelpURL);
        }
        catch (java.io.IOException e1) {
          JOptionPane.showMessageDialog(this,
                                        "Couldn't read help file: " + sURL,
                                        "Error", JOptionPane.ERROR_MESSAGE);
          return;
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Couldn't find file: " + sURL,
                                      "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      m_jLinkButton.setActionCommand("Link");
      m_jLinkButton.setText("GLI Calc Details...");
    }
  }

}
